Setting Live ‘Search Volume’ Tasks

‌This endpoint will provide you with search volume data for the last month, search volume trend for up to 24 past months (that will let you estimate search volume dynamics), current cost-per-click and competition values for paid search.

If your system requires delivering instant results, the Live method is the best solution for you. Unlike the Standard method, this method doesn’t require making separate POST and GET requests to the corresponding endpoints.

If you don’t need to receive data in real-time, you can use the Standard method of data retrieval. This method requires making separate POST and GET requests, but it’s more affordable. Using this method you can retrieve the results after our system collects them.

Historical data is available for 24 months.

checked POST
Pricing

Your account will be charged for each request.
The cost can be calculated on the Pricing page.

All POST data should be sent in the JSON format (UTF-8 encoding). The task setting is done using the POST method. When setting a task, you should send all task parameters in the task array of the generic POST array. You can send up to 2000 API calls per minute, each Live API call can contain only one task. Visit DataForSEO Help Center to get practical tips for request handling depending on your Keyword Data API payload volume.

You will get information for every single keyword in an array.

You can send up to 1000 keywords in one keywords array. Our system will charge your account per each request, no matter what number of keywords an array has, the price for 1 or 1000 keywords will be the same.

Below you will find a detailed description of the fields you can use for setting a task.

Description of the fields for setting a task:

Field nameTypeDescription
keywordsarray

keywords
required field
The maximum number of keywords you can specify: 1000
The maximum number of characters for each keyword: 100
the specified keywords will be converted to lowercase, data will be provided in a separate arraylearn more about rules and limitations of keyword and keywords fields in DataForSEO APIs in this Help Center article

location_namestring

full name of search engine location
required field if you don't specify location_code or location_coordinate
if you use this field, you don't need to specify location_code or location_coordinate
you can receive the list of available locations of the search engine with their location_name by making a separate request to https://api.dataforseo.com/v3/keywords_data/bing/locations
example:
London,England,United Kingdom

location_codeinteger

search engine location code
required field if you don't specify location_name or location_coordinate
if you use this field, you don't need to specify location_name or location_coordinate
you can receive the list of available locations of the search engines with their location_code by making a separate request to https://api.dataforseo.com/v3/keywords_data/bing/locations
example:
2840

location_coordinatestring

GPS coordinates of a location
required field if you don't specify location_name or location_code
if you use this field, you don't need to specify location_name or location_code
location_coordinate parameter should be specified in the "latitude,longitude" format
the data will be provided for the country the specified coordinates belong to
example:
52.6178549,-155.352142

language_namestring

full name of search engine language
required field if you don't specify language_code
if you use this field, you don't need to specify language_code
supported languages:
English, French, German

language_codestring

search engine language code
required field if you don't specify language_name
if you use this field, you don't need to specify language_name
supported languages:
en, fr, de

devicestring

device type
optional field
specify this field if you want to get the data for a particular device type;
possible values: all, mobile, desktop, tablet
default value: all

sort_bystring

results sorting parameters
optional field
Use these parameters to sort the results by search_volume, cpc, competition or relevance in the descending order
default value: relevance

date_fromstring

starting date of the time range
optional field
minimal value: 24 months from today's date;
if you don't specify this field, data will be provided for the last 12 months;
minimum value: two years back from today’s date;
if Status endpoint returns false in the actual_data field, date_from can be set to the month before last and prior;
if Status endpoint returns true in the actual_data field, date_from can be set to the last month and prior;
date format: "yyyy-mm-dd"
example:
"2020-01-01"Note: we do not recommend using a custom time range for the past year's dates

date_tostring

ending date of the time range
optional field
if you don't specify this field, data will be provided for the last 12 months;
minimum value: two years back from today’s date;
maximum value: one month from today's date;
note: we do not recommend using a custom time range for the past year's dates;
date format: "yyyy-mm-dd"
example:
"2020-03-15"Note: we do not recommend using a custom time range for the past year's dates

search_partnersboolean

Bing search partners type
optional field
if you specify true, the results will be delivered for owned, operated, and syndicated networks across Bing, Yahoo, AOL and partner sites that host Bing, AOL, and Yahoo search.
default value: false - results are returned for Bing, AOL, and Yahoo search networks

tagstring

user-defined task identifier
optional field
the character limit is 255
you can use this parameter to identify the task and match it with the result
you will find the specified tag value in the data object of the response


As a response of the API server, you will receive JSON-encoded data containing a tasks array with the information specific to the set tasks.

Description of the fields in the results array:

Field nameTypeDescription
versionstring

the current version of the API

status_codeinteger

general status code
you can find the full list of the response codes here
Note: we strongly recommend designing a necessary system for handling related exceptional or error conditions

status_messagestring

general informational message
you can find the full list of general informational messages here

timestring

execution time, seconds

costfloat

total tasks cost, USD

tasks_countinteger

the number of tasks in the tasks array

tasks_errorinteger

the number of tasks in the tasks array returned with an error

tasksarray

array of tasks

    idstring

task identifier
unique task identifier in our system in the UUID format

    status_codeinteger

status code of the task
generated by DataForSEO; can be within the following range: 10000-60000
you can find the full list of response codes here

    status_messagestring

informational message of the task
you can find the full list of general informational messages here

    timestring

execution time, seconds

    costfloat

cost of the task, USD

    result_countinteger

number of elements in the result array

    patharray

URL path

    dataobject

contains the same parameters that you specified in the POST request

    resultarray

array of results

        keywordstring

keyword in a POST array

        location_codeinteger

location code in a POST array
if there is no data, then the value is_nulln

        language_codestring

language code in a POST array
if there is no data, then the value is_nulln

        search_partnersboolean

indicates whether data from partner networks included in the response

        devicestring

device type in a POST array
if there is no data, then the value is_nulln

        competitionfloat

competition
represents the relative amount of competition associated with the given keyword in paid SERP only. This value is based on Bing Ads data.
Possible values: 0.1, 0.5,0.90.1 - low competition,
0.5 - medium competition,
0.9 - high competition;
if there is no data the value is null

        cpcfloat

cost-per-click
represents the average cost per click (USD) historically paid for the keyword.
if there is no data then the value is_nulln

        search_volumeinteger

monthly average search volume rate
represents either the (approximate) number of searches for the given keyword idea on bing search engine depending on the user’s targeting;
search volume is rounded to the nearest tens;
if there is no data, the value is_nulln

        categoriesarray

product and service categories
our API doesn't return categories for this endpoint: the parameter will always equal null

        monthly_searchesarray

monthly searches
represents the (approximate) number of searches on this keyword idea (as available for the past twelve months), targeted to the specified geographic locations
if there is no data then the value is_nulln

            yearinteger

year

            monthinteger

month

            search_volumeinteger

monthly average search volume rate
search volume is rounded to the nearest tens


‌‌

Instead of ‘login’ and ‘password’ use your credentials from https://app.dataforseo.com/api-access

# Instead of 'login' and 'password' use your credentials from https://app.dataforseo.com/api-access 
login="login" 
password="password" 
cred="$(printf ${login}:${password} | base64)" 
curl --location --request POST "https://api.dataforseo.com/v3/keywords_data/bing/search_volume/live" 
--header "Authorization: Basic ${cred}"  
--header "Content-Type: application/json" 
--data-raw '[
    {
        "location_name": "United States",
        "language_code": "en",
        "keywords": [
            "tom and jerry",
            "silicon valley",
            "spider man"
        ]
    }
]'
<?php
// You can download this file from here https://cdn.dataforseo.com/v3/examples/php/php_RestClient.zip
require('RestClient.php');
$api_url = 'https://api.dataforseo.com/';
try {
	// Instead of 'login' and 'password' use your credentials from https://app.dataforseo.com/api-access
	$client = new RestClient($api_url, null, 'login', 'password');
} catch (RestClientException $e) {
	echo "n";
	print "HTTP code: {$e->getHttpCode()}n";
	print "Error code: {$e->getCode()}n";
	print "Message: {$e->getMessage()}n";
	print  $e->getTraceAsString();
	echo "n";
	exit();
}
$post_array = array();
// simple way to set a task
$post_array[] = array(
	"location_name" => "United States",
	"language_name" => "English",
	"keywords" => array(
		"tom and jerry",
		"silicon valley",
		"spider man"
	)
);
try {
	// POST /v3/keywords_data/bing/search_volume/live
	// the full list of possible parameters is available in documentation
	$result = $client->post('/v3/keywords_data/bing/search_volume/live', $post_array);
	print_r($result);
	// do something with post result
} catch (RestClientException $e) {
	echo "n";
	print "HTTP code: {$e->getHttpCode()}n";
	print "Error code: {$e->getCode()}n";
	print "Message: {$e->getMessage()}n";
	print  $e->getTraceAsString();
	echo "n";
}
$client = null;
?>
const post_array = [];

post_array.push({
  "location_name": "United States",
  "language_name": "English",
  "keywords": ["tom and jerry", "silicon valley", "spider man"]
});

const axios = require('axios');

axios({
  method: 'post',
  url: 'https://api.dataforseo.com/v3/keywords_data/bing/search_volume/live',
  auth: {
    username: 'login',
    password: 'password'
  },
  data: post_array,
  headers: {
    'content-type': 'application/json'
  }
}).then(function (response) {
  var result = response['data']['tasks'];
  // Result data
  console.log(result);
}).catch(function (error) {
  console.log(error);
});
from client import RestClient
# You can download this file from here https://cdn.dataforseo.com/v3/examples/python/python_Client.zip
client = RestClient("login", "password")
post_data = dict()
# simple way to set a task
post_data[len(post_data)] = dict(
    location_name="United States",
    language_name="English",
    keywords=[
        "tom and jerry",
        "silicon valley",
        "spider man"
    ]
)
# POST /v3/keywords_data/bing/search_volume/live
# the full list of possible parameters is available in documentation
response = client.post("/v3/keywords_data/bing/search_volume/live", post_data)
# you can find the full list of the response codes here https://docs.dataforseo.com/v3/appendix/errors
if response["status_code"] == 20000:
    print(response)
    # do something with result
else:
    print("error. Code: %d Message: %s" % (response["status_code"], response["status_message"]))
using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Net.Http;
using System.Net.Http.Headers;
using System.Text;
using System.Threading.Tasks;

namespace DataForSeoDemos
{
    public static partial class Demos
    {
        public static async Task keywords_data_search_volume_live()
        {
            var httpClient = new HttpClient
            {
                BaseAddress = new Uri("https://api.dataforseo.com/"),
                // Instead of 'login' and 'password' use your credentials from https://app.dataforseo.com/api-access
                DefaultRequestHeaders = { Authorization = new AuthenticationHeaderValue("Basic", Convert.ToBase64String(Encoding.ASCII.GetBytes("login:password"))) }
            };
            var postData = new List<object>();
            postData.Add(new
            {
                location_name = "United States",
                language_name = "English",
                keywords = new[]
                    {
                        "tom and jerry",
                        "silicon valley",
                        "spider man"
                    }
            });
            // POST /v3/keywords_data/bing/search_volume/live
            // the full list of possible parameters is available in documentation
            var taskPostResponse = await httpClient.PostAsync("/v3/keywords_data/bing/search_volume/live", new StringContent(JsonConvert.SerializeObject(postData)));
            var result = JsonConvert.DeserializeObject<dynamic>(await taskPostResponse.Content.ReadAsStringAsync());
            // you can find the full list of the response codes here https://docs.dataforseo.com/v3/appendix/errors
            if (result.status_code == 20000)
            {
                // do something with result
                Console.WriteLine(result);
            }
            else
                Console.WriteLine($"error. Code: {result.status_code} Message: {result.status_message}");
        }
    }
}

The above command returns JSON structured like this:

{
  "version": "0.1.20200923",
  "status_code": 20000,
  "status_message": "Ok.",
  "time": "8.2899 sec.",
  "cost": 0.075,
  "tasks_count": 1,
  "tasks_error": 0,
  "tasks": [
    {
      "id": "10201637-1535-0093-0000-6626fb1738be",
      "status_code": 20000,
      "status_message": "Ok.",
      "time": "8.2065 sec.",
      "cost": 0.075,
      "result_count": 3,
      "path": [
        "v3",
        "keywords_data",
        "bing",
        "search_volume",
        "live"
      ],
      "data": {
        "api": "keywords_data",
        "function": "search_volume",
        "se": "bing",
        "location_name": "United States",
        "language_code": "en",
        "device": "mobile",
        "keywords": [
          "tom and jerry",
          "silicon valley",
          "spider man"
        ]
      },
      "result": [
        {
          "keyword": "spider man",
          "location_code": 2840,
          "language_code": "en",
          "search_partners": false,
          "device": "mobile",
          "competition": 0.9,
          "cpc": 0.07,
          "search_volume": 10800,
          "categories": null,
          "monthly_searches": [
            {
              "year": 2020,
              "month": 9,
              "search_volume": 9990
            },
            {
              "year": 2020,
              "month": 8,
              "search_volume": 9540
            },
            {
              "year": 2020,
              "month": 7,
              "search_volume": 10690
            },
            {
              "year": 2020,
              "month": 6,
              "search_volume": 10990
            },
            {
              "year": 2020,
              "month": 5,
              "search_volume": 12530
            },
            {
              "year": 2020,
              "month": 4,
              "search_volume": 13180
            },
            {
              "year": 2020,
              "month": 3,
              "search_volume": 9470
            },
            {
              "year": 2020,
              "month": 2,
              "search_volume": 8180
            },
            {
              "year": 2020,
              "month": 1,
              "search_volume": 8840
            },
            {
              "year": 2019,
              "month": 12,
              "search_volume": 11630
            },
            {
              "year": 2019,
              "month": 11,
              "search_volume": 9850
            },
            {
              "year": 2019,
              "month": 10,
              "search_volume": 14710
            }
          ]
        },
        {
          "keyword": "tom and jerry",
          "location_code": 2840,
          "language_code": "en",
          "search_partners": false,
          "device": "mobile",
          "competition": 0.9,
          "cpc": 0.05,
          "search_volume": 3220,
          "categories": null,
          "monthly_searches": [
            {
              "year": 2020,
              "month": 9,
              "search_volume": 2860
            },
            {
              "year": 2020,
              "month": 8,
              "search_volume": 2830
            },
            {
              "year": 2020,
              "month": 7,
              "search_volume": 3230
            },
            {
              "year": 2020,
              "month": 6,
              "search_volume": 3750
            },
            {
              "year": 2020,
              "month": 5,
              "search_volume": 3910
            },
            {
              "year": 2020,
              "month": 4,
              "search_volume": 3840
            },
            {
              "year": 2020,
              "month": 3,
              "search_volume": 3300
            },
            {
              "year": 2020,
              "month": 2,
              "search_volume": 3540
            },
            {
              "year": 2020,
              "month": 1,
              "search_volume": 3010
            },
            {
              "year": 2019,
              "month": 12,
              "search_volume": 2970
            },
            {
              "year": 2019,
              "month": 11,
              "search_volume": 2590
            },
            {
              "year": 2019,
              "month": 10,
              "search_volume": 2770
            }
          ]
        },
        {
          "keyword": "silicon valley",
          "location_code": 2840,
          "language_code": "en",
          "search_partners": false,
          "device": "mobile",
          "competition": 0.1,
          "cpc": 0,
          "search_volume": 0,
          "categories": null,
          "monthly_searches": [
            {
              "year": 2020,
              "month": 9,
              "search_volume": 0
            },
            {
              "year": 2020,
              "month": 8,
              "search_volume": 0
            },
            {
              "year": 2020,
              "month": 7,
              "search_volume": 0
            },
            {
              "year": 2020,
              "month": 6,
              "search_volume": 0
            },
            {
              "year": 2020,
              "month": 5,
              "search_volume": 0
            },
            {
              "year": 2020,
              "month": 4,
              "search_volume": 0
            },
            {
              "year": 2020,
              "month": 3,
              "search_volume": 0
            },
            {
              "year": 2020,
              "month": 2,
              "search_volume": 0
            },
            {
              "year": 2020,
              "month": 1,
              "search_volume": 0
            },
            {
              "year": 2019,
              "month": 12,
              "search_volume": 10
            },
            {
              "year": 2019,
              "month": 11,
              "search_volume": 0
            },
            {
              "year": 2019,
              "month": 10,
              "search_volume": 0
            }
          ]
        }
      ]
    }
  ]
}